package
{
	import flash.display.*;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.objects.DisplayObject3D;
	
	public class AbaisCamera3D extends Camera3D
	{
		private var CamTarget: DisplayObject3D;	
		private var isOrbiting:Boolean = false;
		private var previousMouseX:Number;
		private var previousMouseY:Number;	
		private var sens:Number;
		private var cameraDistance: Number = 160;
		private var cameraBrake:Number = 0.2;
		private var _CamRotY: Number = 45;
		private var _CamRotX: Number = 180;
		private var differenceY:Number;
		private var differenceX:Number;
		
		public function AbaisCamera3D(_stage:Stage, _cameraDistance:Number, _cameraBrake:Number)
		{
					
			CamTarget = new DisplayObject3D();
			CamTarget.rotationX = 180;
			CamTarget.y = 25;
			
			cameraDistance = _cameraDistance;
			cameraBrake = _cameraBrake;
			
			_stage.addEventListener(Event.ENTER_FRAME, EnterFrame);
			_stage.addEventListener(MouseEvent.MOUSE_DOWN, MouseDown);
			_stage.addEventListener(MouseEvent.MOUSE_UP, MouseUp);
			_stage.addEventListener(MouseEvent.MOUSE_MOVE, MouseMove);
			_stage.addEventListener(MouseEvent.MOUSE_WHEEL, mouseWheelHandler);
			
			super(35);
		}
		
		private function mouseWheelHandler(event:MouseEvent):void
		{
			cameraDistance -= cameraDistance/100*event.delta;
			if (cameraDistance < 50) { cameraDistance = 50 };
			if (cameraDistance > 200) { cameraDistance = 200 };
		}
		
		private function MouseDown(event:MouseEvent):void
		{
			isOrbiting = true;
			previousMouseX = event.stageX;
			previousMouseY = event.stageY;
			if((Math.abs(_CamRotX%360)<90)||(Math.abs(_CamRotX%360)>270)){
				sens = -1;
			}
			if((Math.abs(_CamRotX%360)>=90)&&(Math.abs(_CamRotX%360)<=270)){
				sens = 1;
			}
		}
		
		private function MouseUp(event:MouseEvent):void
		{
			
			isOrbiting = false;		
			
		}
		
		private function MouseMove(event:MouseEvent):void
		{
			differenceX = (event.stageX - previousMouseX)/cameraBrake;
			differenceY = (event.stageY - previousMouseY)/cameraBrake;
			
			if(isOrbiting){
				_CamRotY += differenceX*cameraDistance/50*sens;
				_CamRotX += differenceY*cameraDistance/50;
				previousMouseX = event.stageX;
				previousMouseY = event.stageY;	
			}	
		}

		
		private function EnterFrame(e:Event):void {
			
			this.x = CamTarget.x + cameraDistance*Math.cos(CamTarget.rotationX*Math.PI/180)*Math.sin(CamTarget.rotationY*Math.PI/180);
			this.y = CamTarget.y -cameraDistance*Math.sin(CamTarget.rotationX*Math.PI/180);
			this.z = CamTarget.z +cameraDistance*Math.cos(CamTarget.rotationX*Math.PI/180)*Math.cos(CamTarget.rotationY*Math.PI/180);
			
			this.rotationY = CamTarget.rotationY;
			this.rotationX = 180+CamTarget.rotationX;
			
			CamTarget.rotationY += (_CamRotY-CamTarget.rotationY)/6;
			CamTarget.rotationX += (_CamRotX-CamTarget.rotationX)/6;
			
			//trace(CamTarget.rotationY);
			
		}
		
		
	}
}
